/**
 * Controller for the unknown part of the forest scene.
 * @param {string} sceneId The id of the scene.
 */
function ForestUnknownPryController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var id = sceneId;

    var baseId = "unknownPryBase";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}
    this.base = new BaseController(baseId);
    this.initbite = new InitialBiteController("unknownPryBite");
    this.initbiterape = new InitialBiteRapeController("unknownPryBiteRape");
    this.stay = new StayStillController("unknownStayStill");
    this.suck = new SuckController("unknownSuck");
    this.tail = new TailController("unknownTail");
    this.expose = new ExposeController("unknownExpose");
    this.claw = new ClawController("unknownClaw");
    this.bite = new BiteController("unknownBite");

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    function BaseController(key) {
        var changeId = key + "Change";
        this.get = function () {
            return global.kobold.history.getKey(id, key);
        };
        this.set = function (choice) {
            global.kobold.history.setKey(id, key, choice);
        };
        this.has = function () {
            return global.kobold.history.has(id, key);
        };
        this.change = function () {
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.physical.decrease(5, "Painful thorns");
            });
            return global.ui.change.buildNotification([
                new Change("Painful thorns", "Health", -5)
            ]);
        };
    }

    function InitialBiteController(key) {
        var changeId = key + "Change";
        this.continue = function () {
            global.kobold.history.setKey(id, key, true);
        };
        this.continued = function () {
            return global.kobold.history.has(id, key);
        };
        this.change = function () {
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.physical.decrease(15, "Struggling against thorns");
                global.kobold.status.mental.decrease(15, "Impending rape");
            });
            return global.ui.change.buildNotification([
                new Change("Body encased in thorns", "Health", -5),
                new Change("Struggling against thorns", "Health", -10),
                new Change("Lost fight", "Sanity", -10),
                new Change("Impending rape", "Sanity", -5)
            ]);
        };
    }
    
    function InitialBiteRapeController(key) {
        var changeId = key + "Change";
        var continueChangeId = key + "ContinueChange";
        this.continue = function () {
            global.kobold.history.setKey(id, key, true);
        };
        this.continued = function () {
            return global.kobold.history.has(id, key);
        };
        this.change = function (pants) {
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.body.analVirgin = false;
                global.kobold.status.physical.decrease(5, "Stretched rear");
                global.kobold.status.mental.decrease(25, "Defiled by monster");
                global.kobold.status.exertion.increase(25, "Tentacle buttsex");
                global.kobold.inventory.equipment.strip(SlotEnum.PANTS);
                if(global.kobold.inventory.equipment.underwear) {
                    global.kobold.inventory.equipment.underwear.stain("Honey");
                }
            });
            
            var changes = [
                new Change("Stretched rear", "Health", -5),
                new Change("Defiled by monster", "Sanity", -25),
                new Change("Tentacle buttsex", "Sexual exhaustion", +25, true)
            ];
            
            if(pants) {
                changes.push(new Change("Pants torn", global.kobold.inventory.createItemWithTooltip(pants, true), -1));
            }
            
            return global.ui.change.buildNotification(changes);
        };
        
        this.continueChange = function () {
            global.kobold.history.doIfNotSet(id, continueChangeId, true, function () {
                global.kobold.status.mental.increase(5, "Sheer determination");
                global.kobold.inventory.equipment.wear(new WoolSweater());
            });
            return global.ui.change.buildNotification([
                new Change("Recovered sweater", global.kobold.inventory.createItemWithTooltip(new WoolSweater()), +1),
                new Change("Doubling down", "Sanity", +5)
            ]);
        };
    }

    function StayStillController(key) {
        var changeId = key + "Change";
        this.get = function () {
            return global.kobold.history.getKey(id, key);
        };
        this.set = function (choice) {
            global.kobold.history.setKey(id, key, choice);
        };
        this.has = function () {
            return global.kobold.history.has(id, key);
        };
        this.change = function () {
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.decrease(5, "Mind-boggling aroma");
            });
            return global.ui.change.buildNotification([
                new Change("Mind-altering fragrance", "Sanity", -5)
            ]);
        };
    }

    function SuckController(key) {
        var changeId = key + "Change";
        this.get = function () {
            return global.kobold.history.getKey(id, key);
        };
        this.set = function (choice) {
            global.kobold.history.setKey(id, key, choice);
        };
        this.has = function () {
            return global.kobold.history.has(id, key);
        };
        this.change = function () {
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.decrease(10, "Mind-numbing sap");
            });
            return global.ui.change.buildNotification([
                new Change("Mind-numbing sap", "Sanity", -10)
            ]);
        };
    }
    
    function TailController(key) {
        var changeId = key + "Change";
        var continueChangeId = key + "ContinueChange";
        this.continue = function () {
            global.kobold.history.setKey(id, key, true);
        };
        this.continued = function () {
            return global.kobold.history.has(id, key);
        };
        this.change = function () {
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.decrease(15, "Mind-clouding honey");
                global.kobold.status.exertion.increase(15, "Tentacle facefuck");
                global.kobold.body.oralVirgin = false;
            });
            return global.ui.change.buildNotification([
                new Change("Mind-clouding honey", "Sanity", -15),
                new Change("Tentacle facefuck", "Sexual exhaustion", +15, true)
            ]);
        };
        this.continueChange = function () {
            global.kobold.history.doIfNotSet(id, continueChangeId, true, function () {
                global.kobold.status.physical.increase(5, "Honey-meal");
                global.kobold.status.mental.increase(5, "Honey-meal");
                global.kobold.status.mental.increase(10, "Recovered sweater");
                global.kobold.status.stamina.decrease(15, "Rampant masturbation");
                global.kobold.status.exertion.increase(45, "Rampant masturbation");
                global.kobold.inventory.equipment.wear(new WoolSweater());
            });
            return global.ui.change.buildNotification([
                new Change("Recovered sweater", global.kobold.inventory.createItemWithTooltip(new WoolSweater()), +1),
                new Change("Honey-meal", "Health", +5),
                new Change("Honey-meal", "Sanity", +5),
                new Change("Recovered sweater", "Sanity", +10),
                new Change("Rampant masturbation", "Stamina", -15),
                new Change("Rampant masturbation", "Sexual exhaustion", +45, true)
            ]);
        };
    }
    
    function ExposeController(key) {
        var changeId = key + "Change";
        var continueChangeId = key + "ContinueChange";
        this.continue = function () {
            global.kobold.history.setKey(id, key, true);
        };
        this.continued = function () {
            return global.kobold.history.has(id, key);
        };
        this.change = function () {
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.decrease(25, "Fucked silly");
                global.kobold.status.exertion.increase(25, "Tentacle threesome");
                global.kobold.body.oralVirgin = false;
                if(global.kobold.body.dick) {
                    global.kobold.body.analVirgin = false;
                } else {
                    global.kobold.body.vaginalVirgin = false;
                }
                if(global.kobold.inventory.equipment.underwear) {
                    global.kobold.inventory.equipment.underwear.stain("Honey");
                }
                if(global.kobold.inventory.equipment.pants) {
                    global.kobold.inventory.equipment.pants.stain("Honey");
                }
            });
            return global.ui.change.buildNotification([
                new Change("Fucked silly", "Sanity", -25),
                new Change("Tentacle threesome", "Sexual exhaustion", +25, true)
            ]);
        };
        this.continueChange = function () {
            global.kobold.history.doIfNotSet(id, continueChangeId, true, function () {
                global.kobold.status.physical.increase(5, "Honey-meal");
                global.kobold.status.mental.increase(5, "Honey-meal");
                global.kobold.status.mental.increase(10, "Recovered sweater");
                global.kobold.status.stamina.decrease(15, "Rampant masturbation");
                global.kobold.status.exertion.increase(45, "Rampant masturbation");
                global.kobold.inventory.equipment.wear(new WoolSweater());
            });
            return global.ui.change.buildNotification([
                new Change("Recovered sweater", global.kobold.inventory.createItemWithTooltip(new WoolSweater()), +1),
                new Change("Honey-meal", "Health", +5),
                new Change("Honey-meal", "Sanity", +5),
                new Change("Recovered sweater", "Sanity", +10),
                new Change("Rampant masturbation", "Stamina", -15),
                new Change("Rampant masturbation", "Sexual exhaustion", +45, true)
            ]);
        };
    }

    function ClawController(key) {
        var changeId = key + "Change";
        var changeContinueId = key + "ChangeContinue";
        this.continue = function () {
            global.kobold.history.setKey(id, key, true);
        };
        this.continued = function () {
            return global.kobold.history.has(id, key);
        };
        this.change = function () {
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.physical.decrease(15, "Minor puncture wounds");
            });
            return global.ui.change.buildNotification([
                new Change("Wrist bleeding", "Health", -10),
                new Change("Stepped on a thorny tentacle", "Health", -3),
                new Change("Back thorn-whipped", "Health", -2)
            ]);
        };
        this.changeContinue = function () {
            global.kobold.history.doIfNotSet(id, changeContinueId, true, function () {
                global.kobold.status.mental.increase(10, "Recovered sweater");
                global.kobold.status.stamina.decrease(30, "Running from monster");
                global.kobold.inventory.equipment.wear(new WoolSweater());
            });
            return global.ui.change.buildNotification([
                new Change("Recovered sweater", global.kobold.inventory.createItemWithTooltip(new WoolSweater()), +1),
                new Change("Recovered sweater", "Sanity", +10),
                new Change("Running on fumes", "Stamina", -30)
            ]);
        };
    }

    function BiteController(key) {
        var changeId = key + "Change";
        this.continue = function () {
            global.kobold.history.setKey(id, key, true);
        };
        this.continued = function () {
            return global.kobold.history.has(id, key);
        };
        this.change = function () {
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(10, "Recovered sweater");
                global.kobold.status.stamina.decrease(30, "Running from monster");
                global.kobold.inventory.equipment.wear(new WoolSweater());
            });
            return global.ui.change.buildNotification([
                new Change("Recovered sweater", global.kobold.inventory.createItemWithTooltip(new WoolSweater()), +1),
                new Change("Recovered sweater", "Sanity", +10),
                new Change("Running on fumes", "Stamina", -30)
            ]);
        };
    }
}
