/**
 * Barn section of the farm scene.
 * @param {BreedingFarmController} controller The breeding farm controller.
 */
function BarnForce(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var fuckId = "barnForceFuckButton";
    var freeId = "barnForceFreeButton";

    var toFree = new BarnForceFree(ctrl);
    var toFuck = new BarnForceFuck(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You stealthily approach the vulpine.
                            Being a fox, she may have incredible hearing and a sense of smell well beyond your own,
                            but you are a [b]kobold[/b], one of the sneakiest races around.
                            That, and she's far too occupied with searching through an entire bag full of noisy rubbish to notice you drawing close.
                        [/p]
                        [p]
                            "[color=orange]Aha![/color]" the vixen exclaims, rising to her feet with a single filled vial.
                            Spotting the perfect opportunity to strike, you rush towards her.
                            Embracing her in a powerful [b]bear-hug[/b] from behind,
                            you showcase your incredible strength and [b]lift[/b] Cassidy off the ground.
                        [/p]
                        [p]
                            She yelps in surprise, immediately starting to struggle, kick and squirm, yet your grip is unrelenting.
                            Stepping backwards, you slowly carry the much larger woman all the way to the breeding table.
                            She manages to scratch you a few times using the spurs on the back of her boots,
                            but she fails to land any significant blows.
                            Once close enough to the table, you [b]throw[/b] her ontop of it,
                            rapidly flipping the switch to mechanically pin her in place before she even realizes what's going on.
                        [/p]
                        [p]
                            "[color=orange]What are you doing?! Let me [b]go[/b]![/color]" she demands, screaming so loud it almost gives you a headache.
                            You tell her to shut up, threatening to shove an old, discarded rag you spot on the floor into her muzzle, lest she be quiet.
                            Her angry shouts fade into bestial growling,
                            the canine baring her teeth, attempting to act [b]tough[/b] and [b]dangerous[/b] while being completely restrained.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFuckChoice() {
        var exertion = ctrl.misc.exertion();
        var disabled = ctrl.barnForce.has() ? "disabled" : "";
        var isSelected = ctrl.barnForce.get() === BarnForceChoice.FUCK;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${fuckId}" ${disabled} style="width: 200px;">Torment the bitch</button>`;
        var tooltip = global.parser.parse(`She thought she could have [b]you[/b] raped?
                                           Time to show Cassidy who's the boss around these parts.
                                           Pump her full of aphrodisiac, toy with her for a bit, then leave her on the table to writhe in the mess she created.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width: 200px;">`;
        button += popupContainer;
        button += `</div>`;
        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFreeChoice() {
        var disabled = ctrl.barnForce.has() ? "disabled" : "";
        var isSelected = ctrl.barnForce.get() === BarnForceChoice.FREE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${freeId}" ${disabled} style="width:200px;">Free your peers</button>`;
        var tooltip = global.parser.parse(`Open the cubicles and free the other kobolds. Surely some of them must still be able-minded, right?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildFuckChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildFreeChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + fuckId), $("#" + freeId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFuckListener() {
        $("#" + fuckId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.barnForce.set(BarnForceChoice.FUCK);
            loadNextPart(toFuck);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerFreeListener() {
        $("#" + freeId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.barnForce.set(BarnForceChoice.FREE);
            loadNextPart(toFree);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "barnForce";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.unaware.get() !== BarnUnawareChoice.FORCE) {
            return "";
        }
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.barnForce.change();
        part += buildChoice();
        part += toFree.build();
        part += toFuck.build();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.unaware.get() !== BarnUnawareChoice.FORCE) {
            return;
        }

        toFree.registerListeners();
        toFuck.registerListeners();

        if (ctrl.barnForce.has()) {
            return;
        }

        registerFuckListener();
        registerFreeListener();
    };
}

var BarnForceChoice = {
    FUCK: 1,
    FREE: 2
};
