/**
 * Steal section of the Farmer House scene.
 * @param {BreedingFarmController} controller The Farmer House controller.
 */
function FarmerHouseWrestleChokeContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You exit the bedroom, returning to the living room.
                            Just going out the front door would be risky.
                            [b]Too[/b] risky.
                            You make your way back through the dining room into the kitchen.
                            The woman is gradually starting to wake up, her groans inspiring a sense of fear in you.
                            Looks like your time here is running out, and if you don't escape before she regains her senses fully,
                            you'll be [b]hunted down[/b] by whoever comes to her aid.
                            You bolt past her downed frame into the adjacent hallway, and exit the building the same way you entered it: quietly, and through the back.
                        [/p]
                        [p]
                            The moment you close the door behind you, a cry for help resonates from within the building.
                            Looks like the human woke up.
                            You weren't planning on sticking around anyway.
                            You sprint into the adjacent potato field, and after crossing it with some difficulty,
                            you escape into a small patch of woodland with nobody but the housewife having seen you.
                        [/p]
                        [p]
                            Still, just because you [i]may[/i] not be getting chased, doesn't mean you don't expeditiously make your way back to the eastern Varanar road.
                            The villagers might call the guards to investigate, and should anyone ask,
                            at least while on the road you can [b]pretend[/b] to be a traveller instead of a [b]woman-choking bandit[/b].
                            You're glad you didn't leave the farmer's house empty-handed.
                            Getting your loot might have been a little harder to achieve than what you'd hoped for,
                            but regardless of the amount of extra effort put in, the results are there.
                        [/p]
                        [p]
                            Reaching the road, you continue on your way to Varanar.
                            Hopefully, your streak of good luck will continue in the city.
                            And maybe you won't even have to [b]strangle[/b] anyone, the next time you attempt to break in somewhere.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (!ctrl.choke.continued()) {
            return "";
        }

        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `<span class="todo">There is no content beyond this point.</span>`;
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (!ctrl.choke.continued()) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        //registerContinueListener();
    };
}
