/**
 * Steal section of the Farmer House scene.
 * @param {BreedingFarmController} controller The Farmer House controller.
 */
function FarmerHouseWrestleFail(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You have to stop her from screaming for help.
                            The only way you can do that is by covering her mouth, which you can't reach.
                            You're going to have to [b]bring her down[/b] to your level somehow.
                            And that means you need to get [i]physical[/i].
                        [/p]
                        [p]
                            You wildly charge the scared housewife, roughly grabbing her by the hips, the very centre of her mass, in an attempt to throw her to the floor.
                            While you succeed in throwing off her balance, the woman manages to grab the countertop behind her,
                            preventing herself from falling to the floor despite the most [b]ferocious[/b] pulling, tugging and throwing you manage to muster.
                            Realizing your initial plan has failed, you reach for the human's mouth in an attempt to cover it,
                            but the housewife seems far more [i]feisty[/i] than you'd have thought.
                        [/p]
                        [p]
                            She crudely [b]bashes[/b] your face with her elbow, 
                            her linen shirt doing little to soften the heavy blow to your snout, which sends you recoiling backwards.
                            You let out a pained grunt, clutching your muzzle.
                            Blood flows liberally from your nostrils.
                            The woman, no longer being held by you, flees into adjacent dining room.
                            While you're still reeling from her blow, trying to figure out whether your nose is broken or merely bleeding,
                            the human starts [b]screaming[/b] for help, just as you feared would happen.
                        [/p]
                        [p]
                            Her cries resonate throughout the entire decrepit house, and are undoubtably heard all over the hamlet.
                            Dreading the [i]retribution[/i] of whoever may be coming to [i]help[/i],
                            you collect your senses enough to [b]bolt[/b] out of the back door from whence you came.
                            A small mob of pitchfork-wielding farmers has already formed at the front of the house,
                            being instructed by the lady-in-distress to go after the kobold that spooked her.
                            With nowhere to hide that [i]wouldn't[/i] lead to certain death, you sprint into the nearby potato field, which is luckily unmanned.
                        [/p]
                        [p]
                            As the peasants comb through the house and the back yard,
                            one of them notices you vanishing into a small gathering of trees at the far end of the farmland.
                            Luckily, the group decides [b]not[/b] to give chase.
                            Your lead is too great for them to have any hopes of catching up,
                            and the men consider having chased you off a victory on its own.
                        [/p]
                        [p]
                            Despite having ditched your pursuers, you continue running all the way back to the eastern Varanar road.
                            The villagers might call the guards to investigate, and should anyone ask,
                            at least here you can [b]pretend[/b] to be a traveller instead of a [b]miserable failure[/b] of a thief.
                            Exhausted, you brace yourself against a nearby tree.
                            Your nose still hurts like hell, but the bleeding must have stopped somewhere between the hamlet and the road.
                            You're fairly sure nothing is [i]broken[/i], although it might be wise to see a medician once you're in town.
                        [/p]
                        [p]
                            If you were just a [i]little bit[/i] [b]stronger[/b], you [i]might[/i] have been able to overpower the woman.
                            Alas, what's done is done.
                            You can't win [i]every[/i] fight you get into, and at least you didn't get [b]caught[/b].
                            You've gained nothing, but you haven't lost much either, besides an opportunity and the ability to breathe through your nose.
                            The latter is bound to return once the rest of the blood clears out.
                        [/p]
                        [p]
                            Your brief period of respite over, you continue on the way to Varanar.
                            Hopefully, the humans there will be less [i]hardy[/i].
                            That's what the hamlet's inhabitants constantly claim, anyway.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.wrestleFail();
        part += buildChoice();
        part += `<span class="todo">There is no content beyond this point.</span>`;
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.continued()) {
            return;
        }

        //registerContinueListener();
    };
}
