/**
 * The second part of the introduction.
 * @param {IntroductionController} controller The controller.
 * @param {IntroductionThirdPart} thirdPart The next part to load once finished.
 */
function IntroductionSecondPart(controller, thirdPart) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;
    var nextPart = thirdPart;
    var nameInputId = "namefield";
    var submitNameButtonId = "namebutton";

    var maleDescription = `<div class="text">
                                You are male. You're a bit stronger and tougher than the females of your kind, 
                                yet still pathetically weak compared to anything that isn't a kobold. 
                                You’re wearing nothing but a small, simple ${global.kobold.inventory.createItemWithTooltip(new LoinCloth())}, 
                                which covers the cockslit between your legs quite nice. Your scaly butt, 
                                however, is completely exposed. The only thing covering your virginal rear is your tail.
                            </div>`;

    var femaleDescription = `<div class="text">
                                You are female. You’re not quite as strong as the males of your kind, but you make 
                                up for it by being even lighter, even more nimble and just a little bit more flexible. 
                                Enemies you face might be more concerned with fucking something as small and cute as 
                                yourself rather than trying to hurt you. This may be a good thing, yet if you don’t 
                                watch out you might end up a cum-filled lizard before long. 
                            </div>
                            <div class="text">
                                You wear a baggy pair of brown ${global.kobold.inventory.createItemWithTooltip(new LinenPants())}, 
                                and a matching ${global.kobold.inventory.createItemWithTooltip(new ChestWrap())} which covers up
                                your small breasts quite nicely. Your leg-wear has seen better days. Small holes and
                                cuts dot the fabric in every which way, some large enough to show just a glimmer of your
                                scales beneath. At least your groin and rear are still suitably covered.
                            </div>`;

    var postDescription = `<div class="text">
                                <span class="sneakytext bold">
                                    You can check your attributes in the stats tab, as well as get a physical description of your body.
                                    Your equipment can be found in the inventory tab.
                                    The names of most pieces of equipment can be moused over to reveal a short description of the item.
                                    Your current health, sanity, stamina and sexual exertion may be viewed in the status tab.
                                </span>
                            </div>
                            <div class="text">
                                You used to have a comfortable wool sweater that had kept you warm for many winters, 
                                yet you lost it just a few days ago whilst running from a rather unpleasant group of humans.
                                The soft fabric got caught on a thornbush. Fearing for your life, you slipped out of the 
                                sweater instead of trying to pry it loose. You can't quite remember where all of this happened.
                                The forest can be a confusing place, at times.
                            </div>
                            `;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the enclosing div's starting tag.
     * @param {bool} invisible True if the entire section should be invisible.
     * @returns {string} The starting tag.
     */
    function enclosingDivStart(invisible) {
        var style = invisible ? 'style="display:none;"' : "";
        return `<div id="${that.id}" ${style} >`;
    }

    /**
     * Builds and returns the gender-specific description part.
     * @returns {string} The gender-specific description part.
     */
    function genderDescription() {
        if (ctrl.getGenderChoice() == GenderEnum.MALE) {
            return maleDescription;
        } else {
            return femaleDescription;
        }
    }

    /**
     * Builds and returns the end of the enclosing division.
     * @returns {string} The end of the enclosing division.
     */
    function enclosingDivEnd() {
        return "</div>";
    }

    /**
     * Builds and returns the name selection section.
     * @returns {string} The name selection section.
     */
    function nameSelection() {
        var nameChoiceMade = ctrl.hasMadeNameChoice();
        var disabled = nameChoiceMade ? "disabled" : "";
        var value = nameChoiceMade ? ctrl.getNameChoice() : "Moe";
        var nameSelect = `<div class="choicecontainer">`;
        nameSelect += `<div class="inlinechoiceheader">Your name is:</div>`;
        nameSelect += `<input id="${nameInputId}" class="textinput" maxlength="20" value="${value}" ${disabled}>`;
        nameSelect += `<button id="${submitNameButtonId}" class="button textinputbutton" ${disabled}>Confirm</button>`;
        nameSelect += `</div>`;
        return nameSelect;
    }

    /**
     * Registers a listener disabling the name submit button if no name has been entered.
     */
    function registerNameInputChangeListener() {
        var input = $("#" + nameInputId);
        var button = $("#" + submitNameButtonId);
        input.on('input', function () {
            var value = input.val();
            if (value.length === 0) {
                button.prop('disabled', true);
            } else {
                button.prop('disabled', false);
            }
        });
    }

    /**
     * Registers a listener capable of submitting the name choice.
     */
    function registerNameSubmitListener() {
        var input = $("#" + nameInputId);
        var button = $("#" + submitNameButtonId);
        button.click(function () {
            var value = input.val();
            if (value.length === 0) {
                return;
            }
            button.prop('disabled', true);
            input.prop('disabled', true);
            ctrl.makeNameChoice(value);
            var thirdPart = nextPart.build(true);
            global.ui.appendBeforeFinisher(thirdPart, global.ui.genericHeaderId);
            $("#" + nextPart.id).fadeIn(400);
            nextPart.registerListeners();
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "part2";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (!ctrl.hasMadeGenderChoice()) {
            return "";
        }
        var part = enclosingDivStart(invisible);
        part += genderDescription();
        part += postDescription;
        part += nameSelection();
        part += enclosingDivEnd();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (!ctrl.hasMadeGenderChoice()) {
            return;
        }
        if (ctrl.hasMadeNameChoice()) {
            return;
        }
        registerNameInputChangeListener();
        registerNameSubmitListener();
    };
}
